--5.
USE tempdb;
GO

IF OBJECT_ID ('Dni') IS NOT NULL DROP TABLE Dni;
GO
CREATE TABLE Dni(id INT, den DATETIME);
INSERT Dni VALUES(1, '2008-09-01');
INSERT Dni VALUES(2, '2008-09-03');
INSERT Dni VALUES(3, '2008-09-06');
INSERT Dni VALUES(4, '2008-09-09');
-----------------------

IF OBJECT_ID ('DniPocitadlo') IS NOT NULL DROP TABLE DniPocitadlo;
GO
CREATE TABLE DniPocitadlo(id INT NOT NULL PRIMARY KEY); 

DECLARE @i INT
DECLARE @den1 DATETIME, @den2 DATETIME
SET @i = 1
SET @den1 = (SELECT MIN(d.den)-1 FROM Dni d)
SET @den2 = (SELECT MAX(d.den) FROM Dni d)
SELECT @den1, @den2

WHILE @i <= (SELECT DATEDIFF(dd, @den1, @den2))
	BEGIN
		INSERT DniPocitadlo VALUES (@i)
		SET @i = @i + 1
	END
-----------------------
-- TU SA ZACINA MOJ KOD: --
-- pri prvom spusteni odkomentovat tento kod
-- vytvori sa pomocna tabulka pomTabulka, do ktorej sa ulozia id a nulove riadky
/*
DECLARE @den1 DATETIME, @den2 DATETIME
SET @den1 = (SELECT MIN(d.den)-1 FROM Dni d)

SELECT T1.id, T2.den INTO pomTabulka
	FROM DniPocitadlo T1 
		LEFT OUTER JOIN Dni T2 on T2.den = DATEADD(dd, T1.id, @den1)
	where t2.den is null

*/
--potom sa tieto null riadky nahradia spravnym datumom
DECLARE @den1 DATETIME, @den2 DATETIME
SET @den1 = (SELECT MIN(d.den)-1 FROM Dni d)
select id , case 
	when den is null then @den1+id
	ELSE 'tu sa nic nedeje'
end
from pomTabulka